---
title: String.prototype.padStart()
slug: Web/JavaScript/Reference/Global_Objects/String/padStart
tags:
  - Advanced
  - Intermediate
  - JavaScript
  - Method
  - Prototype
  - Reference
  - String
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>padStart()</code></strong> method pads the current string with another string (multiple times, if needed) until the resulting string reaches the given length.</span> The padding is applied from the start of the current string.</p>

<div>{{EmbedInteractiveExample("pages/js/string-padstart.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>str</var>.padStart(<var>targetLength</var> [, <var>padString</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>targetLength</var></code></dt>
 <dd>The length of the resulting string once the current <code><var>str</var></code> has been padded. If the value is less than <code><var>str.</var>length</code>, then <code><var>str</var></code> is returned as-is.</dd>
 <dt><code><var>padString</var></code> {{optional_inline}}</dt>
 <dd>The string to pad the current <code><var>str</var></code> with. If <code><var>padString</var></code> is too long to stay within the <code><var>targetLength</var></code>, it will be truncated from the end. The default value is "<code> </code>" (<code>U+0020 'SPACE'</code>).</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("String")}} of the specified <code><var>targetLength</var></code> with <code><var>padString</var></code> applied from the start.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_examples">Basic examples</h3>

<pre class="brush: js notranslate">'abc'.padStart(10);         // "       abc"
'abc'.padStart(10, "foo");  // "foofoofabc"
'abc'.padStart(6,"123465"); // "123abc"
'abc'.padStart(8, "0");     // "00000abc"
'abc'.padStart(1);          // "abc"</pre>

<h3 id="Fixed_width_string_number_conversion">Fixed width string number conversion</h3>

<pre class="brush: js notranslate">// Javascript version of: (unsigned)
//  printf "%0*d" width num
function leftFillNum(num, targetLength) {
    return num.toString().padStart(targetLength, 0);
}

const num = 123;
console.log(leftFillNum(num, 5));
// expected output: "00123"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-string.prototype.padstart', 'String.prototype.padStart')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("javascript.builtins.String.padStart")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("String.prototype.padEnd()")}}</li>
 <li><a href="https://github.com/uxitten/polyfill/blob/master/string.polyfill.js">A polyfill</a></li>
</ul>
